/*
 * cdc.h
 *
 */

#ifndef CDC_H_
#define CDC_H_

#include "stdint.h"

void cdc_read(char* data, uint32_t len);

// Reads until either a linefeed is encountered, or maxLen characters are read.
// - Any carriage returns (\r) are deleted/ignored.
// - A line-feed (\n) is converted to a null (\0) so that a null-terminated string is returned.
// - If no line-feed is encountered after maxLen characters, null-termination does NOT occur.
void cdc_read_line(char* data, uint32_t maxLen);
void cdc_write(const char* data, uint32_t length);

void cdc_init();

#endif /* CDC_H_ */
